﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace telefonszamla
{
    class Hivas
    {
        int[] idő = new int[6];
        public int[] Idő { get { return idő; } set { idő = value; } }
        string tel;
        public string Tel { get { return tel; } set { tel = value; } }
        public int Hossz
        {
            get
            { return (idő[3] - idő[0]) * 3600 + (idő[4] - idő[1]) * 60 + idő[5] - idő[2]; }
        }
        public int Perc
        {
            get
            { return Hossz / 60 + (Hossz % 60 == 0 ? 0 : 1); }
        }

        public Hivas(string id, string szám)
        {
            string[] idős = id.Split(' ');
            for (int i = 0; i < 6; i++)
            {
                idő[i] = Convert.ToInt32(idős[i]);
            }
            tel = szám;

        }

        public bool Csúcs()
        {
            return (idő[0] >= 7 && idő[0] < 18);
        }

        public bool Mobil()
        {
            return ((tel.Substring(0, 2) == "39") || (tel.Substring(0, 2) == "41") || (tel.Substring(0, 2) == "71"));
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region 1. feladat - szám típusa;
            Console.Write("Kérem adja meg a telefonszámot: ");
            string tel = Console.ReadLine();
            string körzet = tel.Substring(0, 2);
            Console.WriteLine("A szám {0}", (körzet == "39" || körzet == "71" || körzet == "41") ? "mobil szám" : "vezetékes szám");
            #endregion;
            #region 2. feladat - hívás ideje;
            Console.Write("A hívás ideje - ó p m ó p m:");
            Hivas most = new Hivas(Console.ReadLine(), tel);
            #region egy adatot így is lehet, de ha már van osztály...;
            //string[] idős = Console.ReadLine().Split(' ');
            //int[] idő = new int[idős.Length];
            //for (int i = 0; i < idős.Length; i++)
            //{
            //    idő[i] = Convert.ToInt32(idős[i]);
            //}
            //int hossz = (idő[3] - idő[0]) * 3600 + (idő[4] - idő[1]) * 60 + idő[5] - idő[2];
            //int dijperc = hossz / 60 + (hossz % 60 == 0 ? 0 : 1);
            //Console.WriteLine("a hívás hossza {0} perc ({1} sec)", dijperc, hossz);
            #endregion;
            Console.WriteLine("a hívás hossza {0} perc ({1} sec)", most.Perc, most.Hossz);
            #endregion;
            #region 3. feladat - híváspercek számítása;
            StreamReader be = new StreamReader("HIVASOK.TXT");
            StreamWriter ki = new StreamWriter("percek.txt");
            List<Hivas> Lista = new List<Hivas>();
            while (!be.EndOfStream)
            {
                Hivas uj = new Hivas(be.ReadLine(), be.ReadLine());
                Lista.Add(uj);
                ki.WriteLine("{0} {1}", uj.Perc, uj.Tel);
            }
            be.Close();
            ki.Close();
            #endregion;
            #region 4. feladat - hívásszám bontása;
            int csúcsdb = 0;
            int kivdb = 0;
            foreach (Hivas h in Lista)
            {
                if ((h.Idő[0] >= 7) && (h.Idő[0] < 18))
                {
                    csúcsdb++;
                }
                else
                {
                    kivdb++;
                }
            }
            Console.WriteLine("Csúcsidőben kezdett hívások száma {0}, csúcsidőn kívül {1}", csúcsdb, kivdb);
            #endregion;
            #region 5. feladat - mobil, vezetékes hossz;
            int mobilhossz = 0;
            int vezetékeshossz = 0;
            int mobilperc = 0;
            int vezetékesperc = 0;
            foreach (Hivas h in Lista)
            {
                if ((h.Tel.Substring(0, 2) == "39") || (h.Tel.Substring(0, 2) == "41") || (h.Tel.Substring(0, 2) == "71"))
                {
                    mobilhossz += h.Hossz;
                    mobilperc += h.Perc;
                }
                else
                {
                    vezetékeshossz += h.Hossz;
                    vezetékesperc += h.Perc;
                }
            }
            mobilhossz /= 60;
            vezetékeshossz /= 60;

            Console.WriteLine("Összesen {0} perc hívás mobilon és {1} perc hívás vezetékesen - másodpercekkel számítva", mobilhossz, vezetékeshossz);
            Console.WriteLine("Összesen {0} perc hívás mobilon és {1} perc hívás vezetékesen - hívásidővel számítva", mobilperc, vezetékesperc);
            Console.WriteLine("A feladat mindkét módon értelmezhető szerintem");
            #endregion;
            #region 6. feladat - csúcsdíjas ár;
            double ár = 0;
            foreach (Hivas h in Lista)
            {
                if (h.Csúcs())
                {
                    ár += h.Perc * (h.Mobil() ? 69.175 : 30);
                }
            }
            Console.WriteLine("Csúcsidőben történt hívások összdíja: {0:F2}", ár);
            #endregion;
            Console.ReadLine();
        }
    }
}
